#pragma once
#include "mempool.h"
#include "misc/singleton/singleton.h"

class CORE_API audio_buffer_pool : public singleton_t<audio_buffer_pool> {
public:
    void init(singleton_initliazer& initliazer) override;
    const char* get_name() override { return "audio_buffer_pool"; }

    sample_t* alloc(uint32_t block_size);
    void free(sample_t* block);
protected:
    [[nodiscard]] mempool<>& get_pool() { return pool_; }
private:
    mempool<> pool_ = mempool(1024000 * 4); // 一个4MB的内存池, 如果一个缓冲区大小为1024个样本, 那么这个内存池可以分配1024 * 4个缓冲区
};

DEFINE_SINGLETON_INSTANCE(audio_buffer_pool)
